from example_interfaces.srv import SetBool
import os
import rclpy
import time
from rclpy.node import Node

VOLUME_DEVICE_NUM = 5
VOLUME_TYPE  =      1
VOLUME_UP_CODE =   115
VOLUME_DOWN_CODE = 114
VOLUME_VALUE_SET  = 1
VOLUME_VALUE_CLS  = 0


def GetDevNum():
    cmd = "getevent -p|grep -B 1 adc|grep add|awk '{print $4}'|tr -cd '[0-9]'"
    res = os.popen(cmd)
    num = int(res.read())
    print("devnum:",num)
    res.close()
    return num

class VolControlService(Node):

    def __init__(self):
        super().__init__('volcontrol_service')
        self.srv = self.create_service(SetBool, 'volControl', self.volctrl_callback)
        self.devNum = GetDevNum()
        self.zeroCmd = "sudo sendevent %d 0 0 0"%self.devNum

    def volctrl_callback(self, request, response):
        self.get_logger().info('Incoming request\ndata: %d' % request.data)
        if request.data:
            self.volume_up_control()
        else:
            self.volume_down_control()
        response.success = True
        return response

    #音量+
    def volume_up_control(self):
        cmd = "sudo sendevent %d %d %d %d"%(self.devNum, VOLUME_TYPE, VOLUME_UP_CODE,VOLUME_VALUE_SET)
        end_cmd = "sudo sendevent %d %d %d %d"%(self.devNum, VOLUME_TYPE, VOLUME_UP_CODE,VOLUME_VALUE_CLS)
        os.system(cmd)
        os.system(self.zeroCmd)
        os.system(end_cmd)
        os.system(self.zeroCmd)

    #音量-
    def volume_down_control(self):
        cmd = "sudo sendevent %d %d %d %d"%(self.devNum, VOLUME_TYPE, VOLUME_DOWN_CODE,VOLUME_VALUE_SET)
        end_cmd = "sudo sendevent %d %d %d %d"%(self.devNum, VOLUME_TYPE, VOLUME_DOWN_CODE,VOLUME_VALUE_CLS)
        os.system(cmd)
        os.system(self.zeroCmd)
        os.system(end_cmd)
        os.system(self.zeroCmd)


def main(args=None):
    rclpy.init(args=args)

    volctrl_service = VolControlService()

    rclpy.spin(volctrl_service)

    rclpy.shutdown()


if __name__ == '__main__':
    main()
