#include "example_interfaces/srv/set_bool.hpp"
#include "rclcpp/rclcpp.hpp"
#include <memory>
#include <unistd.h>

#define VOLUME_DEVICE_NUM  5
#define VOLUME_TYPE        1
#define VOLUME_UP_CODE    115
#define VOLUME_DOWN_CODE  114
#define VOLUME_VALUE_SET   1
#define VOLUME_VALUE_CLS   0
char CMD_GET_DEVNUM[128] = "getevent -p|grep -B 1 adc|grep add|awk '{print $4}'|tr -cd '[0-9]'";

int getDevNum()
{
    FILE *cmd;
    char result[1024];

    cmd = popen(CMD_GET_DEVNUM,"r");
    if (cmd == NULL) {
        perror("popen CMD_GET_DEVNUM error");
        exit(EXIT_FAILURE);
    }
    while (fgets(result, sizeof(result), cmd)) {
        printf("%s\n", result);
    }
    pclose(cmd);
    return atoi(result);
}

void control(const std::shared_ptr<example_interfaces::srv::SetBool::Request> request,
      std::shared_ptr<example_interfaces::srv::SetBool::Response> response)
{
	char cmd[1024];
	char zerocmd[1024];
	char end_cmd[1024];
	response->success = 0;
	RCLCPP_INFO(rclcpp::get_logger("rclcpp"), "Incoming request\ndata: %ld",
		    request->data);
	printf("getDevNum:/dev/input/event%d\n", getDevNum());
	
	//0000 0000 00000000
	sprintf(zerocmd,"sudo sendevent %d 0 0 0",getDevNum());
	//音量+
	if (request->data == 1) {
		//0001 0073 00000001
		sprintf(cmd,"sudo sendevent %d %d %d %d",getDevNum(), VOLUME_TYPE, VOLUME_UP_CODE,VOLUME_VALUE_SET);
		system(cmd);
		//0000 0000 00000000
		system(zerocmd);
		//0001 0073 00000000
        sprintf(end_cmd,"sudo sendevent %d %d %d %d",getDevNum(), VOLUME_TYPE, VOLUME_UP_CODE,VOLUME_VALUE_CLS);
        system(end_cmd);
		//0000 0000 00000000
		system(zerocmd);
	}
	//音量-
	else if (request->data == 0) {
		//0001 0072 00000001
		sprintf(cmd,"sudo sendevent %d %d %d %d",getDevNum(), VOLUME_TYPE, VOLUME_DOWN_CODE,VOLUME_VALUE_SET);
		system(cmd);
		//0000 0000 00000000
		system(zerocmd);
		//0001 0072 00000000
        sprintf(end_cmd,"sudo sendevent %d %d %d %d",getDevNum(), VOLUME_TYPE, VOLUME_DOWN_CODE,VOLUME_VALUE_CLS);
        system(end_cmd);
		//0000 0000 00000000
		system(zerocmd);
	}
	else {
		response->success = -1;
	}
	
	RCLCPP_INFO(rclcpp::get_logger("rclcpp"), "sending back response: [%ld]", (long int)response->success);

}

int main(int argc, char **argv)
{
	rclcpp::init(argc, argv);

	//创建名为volume_control_server的节点
	std::shared_ptr<rclcpp::Node> node = rclcpp::Node::make_shared("volume_control_server");


	//创建名为volume_control的服务，绑定回调函数add
	rclcpp::Service<example_interfaces::srv::SetBool>::SharedPtr service =
	node->create_service<example_interfaces::srv::SetBool>("volume_control", &control);


	RCLCPP_INFO(rclcpp::get_logger("rclcpp"), "Ready to volume_control.");

	//入锁，等待客户端请求
	rclcpp::spin(node);
	rclcpp::shutdown();
}
